<template>
  <div>
    <div class="tway-header-1 mb-5" style="font-weight: 400">
      Hola {{ user.firstName }}, te damos la bienvenida a la plataforma que te
      guiará por el camino de la Transformación Digital
    </div>
    <v-row no-gutters class="mb-5">
      <v-col
        v-if="
          percentForm == 100 &&
          subscription.plan &&
          subscription.plan.name === 'FREE'
        "
        :class="desktop ? 'px-3' : 'mb-4'"
      >
        <imtd-caption />
      </v-col>
    </v-row>
    <v-row class="ma-0 mb-6" no-gutters>
      <v-col
        class="ma-0"
        :class="desktop ? 'px-3' : 'mb-4'"
        cols="12"
        xs="12"
        sm="12"
        md="4"
        lg="4"
        xl="4"
      >
        <v-card height="100%" class="pa-3">
          <v-row justify="center" align="center" class="ma-0 fill-height">
            <v-col
              class="ma-0 pa-0"
              cols="4"
              xs="4"
              sm="4"
              md="4"
              lg="4"
              xl="4"
            >
              <v-row class="ma-0" justify="center">
                <v-img
                  :src="require(`@/assets/img/home/card1.svg`)"
                  contain
                  max-height="630"
                />
              </v-row>
            </v-col>
            <v-col
              class="ma-0 pa-0"
              cols="8"
              xs="8"
              sm="8"
              md="8"
              lg="8"
              xl="8"
            >
              <v-row class="ma-0 px-2" justify="start">
                <div class="full-width">
                  <span class="text-card">
                    Estás en el Plan
                    {{
                      subscription.plan.name.charAt(0).toUpperCase() +
                      subscription.plan.name.slice(1).toLowerCase()
                    }}.<br />
                  </span>
                  <span class="text-card">
                    Descubre todos nuestros planes.
                  </span>
                </div>
                <v-btn
                  text
                  color="tway-violet"
                  class="button-text px-0 mt-1"
                  :to="{ name: 'plans' }"
                >
                  Ver detalle
                </v-btn>
              </v-row>
            </v-col>
          </v-row>
        </v-card>
      </v-col>
      <v-col
        class="ma-0"
        :class="desktop ? 'px-3' : 'mb-4'"
        cols="12"
        xs="12"
        sm="12"
        md="4"
        lg="4"
        xl="4"
      >
        <v-card height="100%" class="pa-3">
          <v-row justify="center" align="center" class="ma-0 fill-height">
            <v-col
              class="ma-0 pa-0"
              cols="4"
              xs="4"
              sm="4"
              md="4"
              lg="4"
              xl="4"
            >
              <v-row class="ma-0" justify="center">
                <v-progress-circular
                  :rotate="360"
                  :size="70"
                  :width="15"
                  :value="percentCompany"
                  color="#16C62E"
                >
                  {{ percentCompany }}
                </v-progress-circular>
              </v-row>
            </v-col>
            <v-col
              class="ma-0 pa-0"
              cols="8"
              xs="8"
              sm="8"
              md="8"
              lg="8"
              xl="8"
            >
              <v-row class="ma-0" justify="start">
                <span class="text-card"
                  >Completa tu perfil y avanza en tu camino hacia la
                  Transformación Digital.</span
                >
                <v-btn
                  text
                  color="tway-violet"
                  class="button-text px-0 mt-1"
                  :disabled="percentCompany >= 100"
                  :to="{ name: 'my-profile' }"
                >
                  <span v-if="percentCompany < 100">Completar mi perfil</span>
                  <span v-else>Completo</span>
                </v-btn>
              </v-row>
            </v-col>
          </v-row>
        </v-card>
      </v-col>
      <v-col
        class="ma-0"
        :class="desktop ? 'px-3' : 'mb-4'"
        cols="12"
        xs="12"
        sm="12"
        md="4"
        lg="4"
        xl="4"
      >
        <v-card height="100%" class="pa-3">
          <v-row justify="center" align="center" class="ma-0 fill-height">
            <v-col
              class="ma-0 pa-0"
              cols="4"
              xs="4"
              sm="4"
              md="4"
              lg="4"
              xl="4"
            >
              <v-row class="ma-0" justify="center">
                <v-progress-circular
                  :rotate="360"
                  :size="70"
                  :width="15"
                  :value="percentForm"
                  color="#7319D5"
                >
                  {{ percentForm }}
                </v-progress-circular>
              </v-row>
            </v-col>
            <v-col
              class="ma-0 pa-0"
              cols="8"
              xs="8"
              sm="8"
              md="8"
              lg="8"
              xl="8"
            >
              <v-row class="ma-0" justify="start">
                <span class="text-card">
                  Completa nuestra encuesta y conoce tu Índice de Madurez en
                  Transformación Digital.
                </span>
                <v-btn
                  text
                  color="tway-violet"
                  class="button-text px-0 mt-1"
                  :disabled="percentForm == 100"
                  :to="{ name: 'dti-form' }"
                >
                  <span v-if="percentForm != 100">Completar encuesta</span>
                  <span v-if="percentForm == 100">Completo</span>
                </v-btn>
              </v-row>
            </v-col>
          </v-row>
        </v-card>
      </v-col>
    </v-row>
    <v-row class="ma-0 mb-6" no-gutters>
      <v-col
        class="ma-0"
        :class="desktop ? 'px-3' : 'mb-4'"
        cols="12"
        xs="12"
        sm="12"
        md="4"
        lg="4"
        xl="4"
      >
        <v-card height="100%" class="pa-3">
          <v-row justify="center" align="center" class="ma-0 fill-height">
            <v-col
              class="ma-0 pa-0"
              cols="4"
              xs="4"
              sm="4"
              md="4"
              lg="4"
              xl="4"
            >
              <v-row class="ma-0" justify="center">
                <v-img
                  v-if="percentForm1 == 0"
                  :src="require(`@/assets/img/imo/undraw_imo.png`)"
                  contain
                  max-height="630"
                />
                <v-progress-circular
                  v-if="percentForm1 > 0"
                  :rotate="360"
                  :size="70"
                  :width="15"
                  :value="percentForm1"
                  color="#E30513"
                >
                  {{ percentForm1 }}
                </v-progress-circular>
              </v-row>
            </v-col>
            <v-col
              class="ma-0 pa-0"
              cols="8"
              xs="8"
              sm="8"
              md="8"
              lg="8"
              xl="8"
            >
              <v-row class="ma-0" justify="start">
                <span class="text-card">
                  ¿Quieres conocer el Índice de Madurez Organizacional de tu
                  empresa?
                </span>
                <v-btn
                  text
                  color="tway-violet"
                  class="button-text px-0 mt-1"
                  :disabled="percentForm1 == 100"
                  :to="{ name: 'survey-imo' }"
                >
                  <span v-if="percentForm1 != 0 && percentageimo != 100"
                    >Completar encuesta</span
                  >
                  <span v-if="percentForm1 == 0">Realizar encuesta</span>
                  <span v-if="percentForm1 == 100">Completo</span>
                </v-btn>
              </v-row>
            </v-col>
          </v-row>
        </v-card>
      </v-col>
    </v-row>

    <div class="tway-header-2">Lo último en Transformación Digital</div>
    <trends />
  </div>
</template>

<style lang="scss" scoped>
.text-card {
  font-size: 16px;
  line-height: 20px;
}
.full-width {
  width: 100%;
}
</style>

<script>
import HomeTrends from "@/components/clients/elements/HomeTrends.vue";
import ImtdCaption from "@/components/ImtdCaption.vue";
import CurrentUserService from "@/services/currentUserService";
import CompanyService from "@/services/companyService";
import SubscriptionService from "@/services/subscriptionService";

export default {
  name: "ClientHome",

  components: {
    trends: HomeTrends,
    ImtdCaption,
  },

  props: {
    percentage: {
      type: Number,
      default: 0,
      required: false,
    },
    percentageimo: {
      type: Number,
      default: 0,
      required: false,
    },
  },

  data() {
    return {
      loading: false,
      tab: null,
      dimensions: [],
      dti: false,
      company: null,
      percentCompany: 0,
      percentForm: this.percentage,
      percentForm1: this.percentageimo,
      user: {
        name: "",
      },
      subscription: {
        plan: {
          name: "",
        },
      },
      imtd: 55,
      levels: [
        "La empresa enfrenta el futuro con mentalidad mayoritariamente analógica, sin plan digital. Suma innovaciones aisladas. Opera con sistemas rígidos y poco eficientes para adaptarse a los intereses de los clientes y del mercado. Aspira a incorporar la Transformación Digital, pero las decisiones son tardías y lentas. Falta un liderazgo que impulse el proceso de transformación. Aparecen resistencias. La organización persiste en hacer las cosas como hasta ahora, sin integrar competencias digitales. La organización está enfocada en una rentabilidad de corto plazo. Su competitividad futura es baja.",
        "La empresa integra innovaciones en procesos específicos para bajar costos y aumentar margen. Resuelve problemas actuales con tecnologías, más que cambiar la forma de hacer las cosas. Pone en marca acciones digitales, sin claridad sobre el valor que tendrán en el negocio futuro. Persisten resistencias y una cultura de trabajo en silos, sin lograr agilizar la transformación digital, ni impregnar a toda la organización. Necesita un propósito alineado a un proyecto digital estructurado, y liderazgos comprometidos con una ruta hacia la Transformación integral. Incorpora competencias digitales para adoptar nuevos modelos de negocio. Pone en marcha algunos servicios con foco en los clientes y su comportamiento, priorizando acciones de marketing.",
        "La empresa alinea su propósito a la Transformación Digital como estrategia de negocio. Proyecta una cultura orientada al cliente y data driven, para tomar decisiones, escalar el negocio, aumentar la velocidad de salida al mercado y adaptar la propuesta de valor a escenarios dinámicos. Establece liderazgos comprometidos con los cambios. Incorpora modelos de aprendizaje continuo. Impulsa la colaboración entre equipos autónomos y multidisciplinarios. Establece alianzas con ecosistemas externos para lograr eficiencias y mejorar la rentabilidad futura. La data, innovación y las tecnologías son activos estratégicos transversales para volverse más ágil, automatizar procesos y escalar. Mapea la experiencia de los clientes de principio a fin, monitorea su satisfacción, interactúa con ellos en espacios digitales y gestiona activamente fallas operacionales.",
        "La estrategia, proyecto y gestión de Transformación Digital es central y transversal. Completamente integrada al negocio, busca crear ventajas competitivas a largo plazo en contextos dinámicos. La tecnología es su aliado en la nube. Promueve una nueva mentalidad a través de un propósito vinculante, potenciando una inteligencia colectiva. Nace una cultura corporativa flexible, auto motivada y abierta a la innovación. Surgen liderazgos que permiten orquestar los cambios de forma ágil, distribuyendo las decisiones críticas. Cuenta con un ecosistema que incentiva el aprendizaje continuo, incorporando los errores o fallos de forma constructiva, prototipando para escalar rápido. Los clientes son entendidos como una red, los conecta de manera multicanal y sin fricciones, motivándolos a colaborar en crear su oferta de valor. La data es un activo para conocerlos y anticiparse a la futura interacción que tendrán con sus productos y servicios; el fin, entregar una experiencia exitosa.",
      ],
    };
  },

  created() {
    this.getCompanyProfile();
    this.getCurrenUserData();
    this.getCurrentUserSubscription();
  },

  methods: {
    getCompanyProfile() {
      CompanyService.getCompanyProfile().then((company) => {
        this.company = company;
        let array = Object.entries(this.company);
        let total = 9;
        let nullables = 0;
        for (let index = 0; index < array.length; index++) {
          const key = array[index][0];
          const val = array[index][1];
          if (
            key != "address" &&
            key != "id" &&
            key != "enabled" &&
            key != "lastUpdate" &&
            key != "size" &&
            key != "type" &&
            val == null
          ) {
            nullables++;
          }
          if (
            (key == "size" || key == "industrialSector") &&
            ((Array.isArray(val) && val.length == 0) || val == null)
          ) {
            nullables++;
          }
        }
        this.percentCompany = Math.floor(((total - nullables) / total) * 100);
      });
    },

    getCurrentUserSubscription() {
      SubscriptionService.getCurrentUserSubscription()
        .then((subscription) => {
          this.subscription = subscription;
        })
        .catch((err) => this.$log.error(err));
    },
    getCurrenUserData() {
      CurrentUserService.currentUserData()
        .then((userData) => (this.user = userData))
        .catch((err) => this.$log.error(err));
    },
  },
  watch: {
    percentage() {
      this.percentForm = this.percentage;
    },
    percentageimo() {
      this.percentForm1 = this.percentageimo;
    },
  },
  computed: {
    mobile() {
      return this.$vuetify.breakpoint.sm || this.$vuetify.breakpoint.xs;
    },
    desktop() {
      return (
        this.$vuetify.breakpoint.md ||
        this.$vuetify.breakpoint.lg ||
        this.$vuetify.breakpoint.xl
      );
    },
  },
};
</script>
